package com.hotwj.platform.config.signAuditPermissionConfig.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.signAuditPermissionConfig.domain.HotSignAuditPermissionConfig;
import com.hotwj.platform.config.signAuditPermissionConfig.domain.bo.HotSignAuditPermissionConfigBo;
import com.hotwj.platform.config.signAuditPermissionConfig.domain.vo.HotSignAuditPermissionConfigVo;
import com.hotwj.platform.config.signAuditPermissionConfig.mapper.HotSignAuditPermissionConfigMapper;
import com.hotwj.platform.config.signAuditPermissionConfig.service.IHotSignAuditPermissionConfigService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 签字审核权限配置Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-29
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotSignAuditPermissionConfigServiceImpl implements IHotSignAuditPermissionConfigService {

    private final HotSignAuditPermissionConfigMapper baseMapper;

    /**
     * 查询签字审核权限配置
     *
     * @param id 主键
     * @return 签字审核权限配置
     */
    @Override
    public HotSignAuditPermissionConfigVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询签字审核权限配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 签字审核权限配置分页列表
     */
    @Override
    public TableDataInfo<HotSignAuditPermissionConfigVo> queryPageList(HotSignAuditPermissionConfigBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotSignAuditPermissionConfig> lqw = buildQueryWrapper(bo);
        Page<HotSignAuditPermissionConfigVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的签字审核权限配置列表
     *
     * @param bo 查询条件
     * @return 签字审核权限配置列表
     */
    @Override
    public List<HotSignAuditPermissionConfigVo> queryList(HotSignAuditPermissionConfigBo bo) {
        LambdaQueryWrapper<HotSignAuditPermissionConfig> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotSignAuditPermissionConfig> buildQueryWrapper(HotSignAuditPermissionConfigBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotSignAuditPermissionConfig> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotSignAuditPermissionConfig::getId);
        lqw.eq(bo.getCompanyId() != null, HotSignAuditPermissionConfig::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getBizType() != null, HotSignAuditPermissionConfig::getBizType, bo.getBizType());
        lqw.eq(bo.getAuditorId() != null, HotSignAuditPermissionConfig::getAuditorId, bo.getAuditorId());
        lqw.like(StringUtils.isNotBlank(bo.getAuditorName()), HotSignAuditPermissionConfig::getAuditorName, bo.getAuditorName());
        lqw.eq(StringUtils.isNotBlank(bo.getPhone()), HotSignAuditPermissionConfig::getPhone, bo.getPhone());
        lqw.eq(HotSignAuditPermissionConfig::getIsDeleted, 0L);
        return lqw;
    }

    /**
     * 新增签字审核权限配置
     *
     * @param bo 签字审核权限配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotSignAuditPermissionConfigBo bo) {
        HotSignAuditPermissionConfig add = MapstructUtils.convert(bo, HotSignAuditPermissionConfig.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改签字审核权限配置
     *
     * @param bo 签字审核权限配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotSignAuditPermissionConfigBo bo) {
        HotSignAuditPermissionConfig update = MapstructUtils.convert(bo, HotSignAuditPermissionConfig.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotSignAuditPermissionConfig entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除签字审核权限配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
